unofficial mirror of guix-patches@gnu.org 
 help / color / mirror / code / Atom feed
From: Oleg Pykhalov <go.wigust@gmail.com>
To: 50967@debbugs.gnu.org
Cc: "Ludovic Courtès" <ludo@gnu.org>,
	"Andrew Tropin" <andrew@trop.in>,
	"Xinglu Chen" <public@yoctocell.xyz>,
	zimoun <zimon.toutoune@gmail.com>
Subject: [bug#50967] [PATCH 00/12] Move (gnu home-services XYZ) to (gnu services XYZ)
Date: Thu, 07 Oct 2021 01:15:37 +0300	[thread overview]
Message-ID: <871r4x4x6e.fsf_-_@gmail.com> (raw)
In-Reply-To: <878rz54xmy.fsf@gmail.com> (Oleg Pykhalov's message of "Thu, 07 Oct 2021 01:05:41 +0300")


[-- Attachment #1.1: Type: text/plain, Size: 442 bytes --]

Oleg Pykhalov <go.wigust@gmail.com> writes:

> This patch fixes user's files corruption.  Also, I applied suggestions
> about commit message, thanks zimoun!

Also, in addion I forget to:

Replace '#!/usr/bin/env bash' with '#!/bin/bash'

Maybe a /bin/sh would be more Guix friendly, but shellcheck warns about
export -f does not exist in posix shell.  Thoughts are welcome ;-)


Remove a unnecessary subshell in run_guix_home_without_home.



[-- Attachment #1.2: minor fixes for guix-test.sh --]
[-- Type: text/x-patch, Size: 4824 bytes --]

From 6351e3f099d3c09143c5f0289216d52ee45664d9 Mon Sep 17 00:00:00 2001
From: Oleg Pykhalov <go.wigust@gmail.com>
Date: Tue, 5 Oct 2021 02:10:25 +0300
Subject: [PATCH] scripts: home: Make sure profile directory exists.

* guix/scripts/home.scm (process-action): Make sure profile directory exists.
* tests/guix-home.sh: New file.
* Makefile.am (SH_TESTS): Add this.
---
 Makefile.am           |  1 +
 guix/scripts/home.scm |  2 ++
 tests/guix-home.sh    | 84 +++++++++++++++++++++++++++++++++++++++++++
 3 files changed, 87 insertions(+)
 create mode 100644 tests/guix-home.sh

diff --git a/Makefile.am b/Makefile.am
index b66789fa0b..5bf2567dc8 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -546,6 +546,7 @@ SH_TESTS =					\
   tests/guix-package-aliases.sh			\
   tests/guix-package-net.sh			\
   tests/guix-system.sh				\
+  tests/guix-home.sh				\
   tests/guix-archive.sh				\
   tests/guix-authenticate.sh			\
   tests/guix-environment.sh			\
diff --git a/guix/scripts/home.scm b/guix/scripts/home.scm
index 75df6d707d..115dfadb57 100644
--- a/guix/scripts/home.scm
+++ b/guix/scripts/home.scm
@@ -1,6 +1,7 @@
 ;;; GNU Guix --- Functional package management for GNU
 ;;; Copyright © 2021 Andrew Tropin <andrew@trop.in>
 ;;; Copyright © 2021 Xinglu Chen <public@yoctocell.xyz>
+;;; Copyright © 2021 Oleg Pykhalov <go.wigust@gmail.com>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -179,6 +180,7 @@ ACTION must be one of the sub-commands that takes a home environment
 declaration as an argument (a file name.)  OPTS is the raw alist of options
 resulting from command-line parsing."
   (define (ensure-home-environment file-or-exp obj)
+    (ensure-profile-directory)
     (unless (home-environment? obj)
       (leave (G_ "'~a' does not return a home environment ~%")
              file-or-exp))
diff --git a/tests/guix-home.sh b/tests/guix-home.sh
new file mode 100644
index 0000000000..b0b85737b0
--- /dev/null
+++ b/tests/guix-home.sh
@@ -0,0 +1,84 @@
+#!/bin/bash
+
+# GNU Guix --- Functional package management for GNU
+# Copyright © 2021 Oleg Pykhalov <go.wigust@gmail.com>
+#
+# This file is part of GNU Guix.
+#
+# GNU Guix is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or (at
+# your option) any later version.
+#
+# GNU Guix is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
+
+#
+# Test the 'guix home' using the external store, if any.
+#
+
+guix home --version
+
+NIX_STORE_DIR="$(guile -c '(use-modules (guix config))(display %storedir)')"
+localstatedir="$(guile -c '(use-modules (guix config))(display %localstatedir)')"
+GUIX_DAEMON_SOCKET="$localstatedir/guix/daemon-socket/socket"
+export NIX_STORE_DIR GUIX_DAEMON_SOCKET
+
+# Run tests only when a "real" daemon is available.
+if ! guile -c '(use-modules (guix)) (exit (false-if-exception (open-connection)))'
+then
+    exit 77
+fi
+
+STORE_PARENT="$(dirname "$NIX_STORE_DIR")"
+export STORE_PARENT
+if test "$STORE_PARENT" = "/"; then exit 77; fi
+
+run_guix_home_without_home()
+{
+    # Save current directory (Guix source directory) for later mount
+    test_directory="$(mktemp -d)"
+    trap 'umount $test_directory; rmdir $test_directory' EXIT
+    mount --bind "$PWD" "$test_directory"
+
+    # Make $HOME directory empty to preserve user's files
+    mount --types tmpfs none "$HOME"
+
+    # Mount Guix source directory in a clean environment
+    mkdir -p "$PWD"
+    mount --bind "$test_directory" "$PWD"
+    cd "$PWD" || exit 77
+
+    cat > "dot-bashrc" <<'EOF'
+# dot-bashrc test file for guix home
+EOF
+
+    cat > "home.scm" <<'EOF'
+(use-modules (gnu home)
+             (gnu home-services)
+             (gnu home services shells)
+             (gnu services)
+             (guix gexp))
+
+(home-environment
+ (services
+  (list
+   (service home-bash-service-type
+            (home-bash-configuration
+             (guix-defaults? #t)
+             (bashrc
+              (list
+               (local-file (string-append (dirname (current-filename))
+                                          "/dot-bashrc")))))))))
+EOF
+
+    guix home reconfigure "${test_directory}/home.scm"
+}
+export -f run_guix_home_without_home
+
+unshare --mount --map-root-user --fork sh -c "run_guix_home_without_home"
-- 
2.33.0


[-- Attachment #2: signature.asc --]
[-- Type: application/pgp-signature, Size: 861 bytes --]

  reply	other threads:[~2021-10-06 22:16 UTC|newest]

Thread overview: 64+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2021-10-02 13:43 [bug#50967] [PATCH 00/12] Move (gnu home-services XYZ) to (gnu services XYZ) Oleg Pykhalov
2021-10-02 13:45 ` [bug#50967] [PATCH 01/12] tests: Add tests for guix home cli Oleg Pykhalov
2021-10-02 13:45   ` [bug#50967] [PATCH 02/12] gnu: home-services: Move configuration to (gnu services) Oleg Pykhalov
2021-10-02 13:45   ` [bug#50967] [PATCH 03/12] gnu: home-services: Move symlink-manager " Oleg Pykhalov
2021-10-02 13:45   ` [bug#50967] [PATCH 04/12] gnu: home-services: Move utils " Oleg Pykhalov
2021-10-02 13:45   ` [bug#50967] [PATCH 05/12] gnu: home-services: Move fontutils " Oleg Pykhalov
2021-10-02 13:45   ` [bug#50967] [PATCH 06/12] gnu: home-services: Move shells " Oleg Pykhalov
2021-10-02 13:45   ` [bug#50967] [PATCH 07/12] gnu: home-services: Move xdg " Oleg Pykhalov
2021-10-02 13:45   ` [bug#50967] [PATCH 08/12] gnu: home-services: Move shepherd " Oleg Pykhalov
2021-10-02 13:46   ` [bug#50967] [PATCH 09/12] gnu: home-services: Move mcron " Oleg Pykhalov
2021-10-02 13:46   ` [bug#50967] [PATCH 10/12] gnu: home-services: Change %service-type-path and filter services Oleg Pykhalov
2021-10-02 13:46   ` [bug#50967] [PATCH 11/12] scripts: home: (gnu home-services bash) -> (gnu services bash) Oleg Pykhalov
2021-10-02 13:46   ` [bug#50967] [PATCH 12/12] doc: (gnu home-services) -> (gnu services) Oleg Pykhalov
2021-10-02 16:38 ` [bug#50967] [PATCH 01/14] tests: Add tests for guix home cli Oleg Pykhalov
2021-10-02 16:38   ` [bug#50967] [PATCH 02/14] gnu: home-services: Move configuration to (gnu home services) Oleg Pykhalov
2021-10-02 18:37     ` Xinglu Chen
2021-10-02 16:38   ` [bug#50967] [PATCH 03/14] gnu: home-services: Move symlink-manager " Oleg Pykhalov
2021-10-02 16:38   ` [bug#50967] [PATCH 04/14] gnu: home-services: Move utils " Oleg Pykhalov
2021-10-02 16:38   ` [bug#50967] [PATCH 05/14] gnu: home-services: Move fontutils to (gnu services) Oleg Pykhalov
2021-10-02 16:38   ` [bug#50967] [PATCH 06/14] gnu: home-services: Move shells to (gnu home services) Oleg Pykhalov
2021-10-02 16:38   ` [bug#50967] [PATCH 07/14] gnu: home-services: Move xdg " Oleg Pykhalov
2021-10-02 16:38   ` [bug#50967] [PATCH 08/14] gnu: home-services: Move shepherd " Oleg Pykhalov
2021-10-02 16:38   ` [bug#50967] [PATCH 09/14] gnu: home-services: Move mcron " Oleg Pykhalov
2021-10-02 16:38   ` [bug#50967] [PATCH 10/14] scripts: home: (gnu home-services bash) -> (gnu home services bash) Oleg Pykhalov
2021-10-02 16:38   ` [bug#50967] [PATCH 11/14] doc: (gnu home-services) -> (gnu home services) Oleg Pykhalov
2021-10-02 16:38   ` [bug#50967] [PATCH 12/14] gnu: home-services: Update %service-type-path Oleg Pykhalov
2021-10-04 14:01     ` [bug#50967] [PATCH 00/12] Move (gnu home-services XYZ) to (gnu services XYZ) Ludovic Courtès
2021-10-02 16:38   ` [bug#50967] [PATCH 13/14] home: services: configuration: Support file-like objects Oleg Pykhalov
2021-10-02 18:35     ` Xinglu Chen
2021-10-04 14:04       ` [bug#50967] [PATCH 00/12] Move (gnu home-services XYZ) to (gnu services XYZ) Ludovic Courtès
2021-10-06  8:15         ` [bug#50967] file-like objects instead of gexps Andrew Tropin
2021-10-08  7:56           ` Ludovic Courtès
2021-10-08 10:00             ` Andrew Tropin
2021-10-09 13:34               ` Ludovic Courtès
2021-10-14  8:32                 ` Andrew Tropin
2021-10-08 13:45           ` Xinglu Chen
2021-10-08 14:34             ` Andrew Tropin
2021-10-08 10:06     ` [bug#50967] [PATCH 13/14] home: services: configuration: Support file-like objects Andrew Tropin
2021-10-14  7:08     ` Andrew Tropin
2021-10-02 16:38   ` [bug#50967] [PATCH 14/14] doc: Document guix home import Oleg Pykhalov
2021-10-02 18:42     ` Xinglu Chen
2021-10-02 19:45       ` Oleg Pykhalov
2021-10-04 13:58   ` [bug#50967] [PATCH 00/12] Move (gnu home-services XYZ) to (gnu services XYZ) Ludovic Courtès
2021-10-04 23:13     ` [bug#50967] [PATCH 1/3] gnu: Move (gnu home-services) to (gnu home services) Oleg Pykhalov
2021-10-04 23:13       ` [bug#50967] [PATCH 2/3] home: services: configuration: Support file-like objects Oleg Pykhalov
2021-10-04 23:13       ` [bug#50967] [PATCH 3/3] guix: scripts: Make sure profile directory exists Oleg Pykhalov
2021-10-05 10:20         ` Oleg Pykhalov
2021-10-06 21:22           ` [bug#50967] [PATCH 00/12] Move (gnu home-services XYZ) to (gnu services XYZ) Ludovic Courtès
2021-10-06 22:05         ` [bug#50967] [PATCH 3/3] guix: scripts: Make sure profile directory exists Oleg Pykhalov
2021-10-06 22:15           ` Oleg Pykhalov [this message]
2021-10-07  6:37             ` [bug#50967] [PATCH 00/12] Move (gnu home-services XYZ) to (gnu services XYZ) Maxime Devos
2021-10-07  9:56               ` Oleg Pykhalov
2021-10-07 16:43                 ` Maxime Devos
2021-10-08 22:44               ` Ludovic Courtès
2021-10-08 22:57           ` Ludovic Courtès
2021-10-09 12:34             ` Oleg Pykhalov
2021-10-09 12:45               ` Oleg Pykhalov
2021-10-09 14:34               ` Ludovic Courtès
2021-10-09 19:39                 ` bug#50967: " Oleg Pykhalov
2021-10-08 12:44       ` [bug#50967] " Oleg Pykhalov
2021-10-08 14:27         ` Andrew Tropin
2021-10-08 22:46           ` Ludovic Courtès
2021-10-08 22:49       ` Ludovic Courtès
2021-10-02 20:13 ` [bug#50967] [PATCH] home: services: configuration: Move and refactor content Oleg Pykhalov

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

  List information: https://guix.gnu.org/

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=871r4x4x6e.fsf_-_@gmail.com \
    --to=go.wigust@gmail.com \
    --cc=50967@debbugs.gnu.org \
    --cc=andrew@trop.in \
    --cc=ludo@gnu.org \
    --cc=public@yoctocell.xyz \
    --cc=zimon.toutoune@gmail.com \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
Code repositories for project(s) associated with this public inbox

	https://git.savannah.gnu.org/cgit/guix.git

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).